var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
import { fromEvent as fromEvent$1 } from 'rxjs/observable/fromEvent';
import { merge as merge$1 } from 'rxjs/observable/merge';
import 'rxjs/add/operator/debounce';
import 'rxjs/add/operator/debounceTime';
import 'rxjs/add/operator/distinctUntilChanged';
import 'rxjs/add/operator/filter';
import 'rxjs/add/operator/first';
import 'rxjs/add/operator/ignoreElements';
import 'rxjs/add/operator/last';
import 'rxjs/add/operator/sample';
import 'rxjs/add/operator/single';
import 'rxjs/add/operator/skip';
import 'rxjs/add/operator/skipUntil';
import 'rxjs/add/operator/skipWhile';
import 'rxjs/add/operator/take';
import 'rxjs/add/operator/takeUntil';
import 'rxjs/add/operator/takeWhile';
import 'rxjs/add/operator/takeLast';
import 'rxjs/add/operator/startWith';
import 'rxjs/add/operator/throttle';
import 'rxjs/add/operator/throttleTime';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/reduce';
import 'rxjs/add/operator/scan';
import 'rxjs/add/operator/concatMap';
import 'rxjs/add/operator/switchMap';
import 'rxjs/add/operator/combineAll';
import 'rxjs/add/operator/withLatestFrom';
import 'rxjs/add/operator/bufferCount';
import 'rxjs/add/operator/switchMapTo';
import 'rxjs/add/operator/every';
import 'rxjs/add/operator/defaultIfEmpty';
import 'rxjs/add/operator/do';
import { HostListener } from '@angular/core';
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @record
 */
var ANNOTATIONS = '__annotations__';
var PARAMETERS = '__paramaters__';
var PROP_METADATA = '__prop__metadata__';
/**
 * @param {?} name
 * @param {?=} props
 * @param {?=} parentClass
 * @param {?=} chainFn
 * @return {?}
 */
function makeDecorator(name, props, parentClass, chainFn) {
    var /** @type {?} */ metaCtor = makeMetadataCtor(props);
    /**
     * @param {?} objOrType
     * @return {?}
     */
    function DecoratorFactory(objOrType) {
        if (this instanceof DecoratorFactory) {
            metaCtor.call(this, objOrType);
            return this;
        }
        var /** @type {?} */ annotationInstance = new ((DecoratorFactory))(objOrType);
        var /** @type {?} */ TypeDecorator = (function TypeDecorator(cls) {
            var /** @type {?} */ annotations = cls.hasOwnProperty(ANNOTATIONS) ?
                ((cls))[ANNOTATIONS] :
                Object.defineProperty(cls, ANNOTATIONS, { value: [] })[ANNOTATIONS];
            annotations.push(annotationInstance);
            return cls;
        });
        if (chainFn)
            chainFn(TypeDecorator);
        return TypeDecorator;
    }
    if (parentClass) {
        DecoratorFactory.prototype = Object.create(parentClass.prototype);
    }
    DecoratorFactory.prototype.ngMetadataName = name;
    ((DecoratorFactory)).annotationCls = DecoratorFactory;
    return /** @type {?} */ (DecoratorFactory);
}
/**
 * @param {?=} props
 * @return {?}
 */
function makeMetadataCtor(props) {
    return function ctor() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (props) {
            var /** @type {?} */ values = props.apply(void 0, __spread(args));
            for (var /** @type {?} */ propName in values) {
                this[propName] = values[propName];
            }
        }
    };
}
/**
 * @param {?} name
 * @param {?=} props
 * @param {?=} parentClass
 * @return {?}
 */
function makeParamDecorator(name, props, parentClass) {
    var /** @type {?} */ metaCtor = makeMetadataCtor(props);
    /**
     * @param {...?} args
     * @return {?}
     */
    function ParamDecoratorFactory() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (this instanceof ParamDecoratorFactory) {
            metaCtor.apply(this, args);
            return this;
        }
        var /** @type {?} */ annotationInstance = new (((ParamDecoratorFactory)).bind.apply(((ParamDecoratorFactory)), __spread([void 0], args)))();
        ((ParamDecorator)).annotation = annotationInstance;
        return ParamDecorator;
        /**
         * @param {?} cls
         * @param {?} unusedKey
         * @param {?} index
         * @return {?}
         */
        function ParamDecorator(cls, unusedKey, index) {
            var /** @type {?} */ parameters = cls.hasOwnProperty(PARAMETERS) ?
                ((cls))[PARAMETERS] :
                Object.defineProperty(cls, PARAMETERS, { value: [] })[PARAMETERS];
            while (parameters.length <= index) {
                parameters.push(null);
            }
            (parameters[index] = parameters[index] || []).push(annotationInstance);
            return cls;
        }
    }
    if (parentClass) {
        ParamDecoratorFactory.prototype = Object.create(parentClass.prototype);
    }
    ParamDecoratorFactory.prototype.ngMetadataName = name;
    ((ParamDecoratorFactory)).annotationCls = ParamDecoratorFactory;
    return ParamDecoratorFactory;
}
/**
 * @param {?} name
 * @param {?=} props
 * @param {?=} parentClass
 * @return {?}
 */
function makePropDecorator(name, props, parentClass) {
    var /** @type {?} */ metaCtor = makeMetadataCtor(props);
    /**
     * @param {...?} args
     * @return {?}
     */
    function PropDecoratorFactory() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (this instanceof PropDecoratorFactory) {
            metaCtor.apply(this, args);
            return this;
        }
        var /** @type {?} */ decoratorInstance = new (((PropDecoratorFactory)).bind.apply(((PropDecoratorFactory)), __spread([void 0], args)))();
        return function PropDecorator(target, name) {
            var /** @type {?} */ constructor = target.constructor;
            var /** @type {?} */ meta = constructor.hasOwnProperty(PROP_METADATA) ?
                ((constructor))[PROP_METADATA] :
                Object.defineProperty(constructor, PROP_METADATA, { value: {} })[PROP_METADATA];
            meta[name] = meta.hasOwnProperty(name) && meta[name] || [];
            meta[name].unshift(decoratorInstance);
        };
    }
    if (parentClass) {
        PropDecoratorFactory.prototype = Object.create(parentClass.prototype);
    }
    PropDecoratorFactory.prototype.ngMetadataName = name;
    ((PropDecoratorFactory)).annotationCls = PropDecoratorFactory;
    return PropDecoratorFactory;
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var parse = function (val) {
    return (typeof val === 'boolean')
        ? (!!val ? 1 : 0)
        : val;
};
/**
 * @record
 */
var styledash = function (target) {
    if (target === void 0) { target = document.documentElement; }
    return ({
        set: function (key, val) {
            if (typeof key === 'object' && val === undefined) {
                return Object.keys(key)
                    .forEach(function (subKey) { return styledash(target).set(subKey, key[subKey]); });
            }
            if (typeof val === 'object') {
                return Object.keys(val).forEach(function (subkey) {
                    styledash(target).set(key + "-" + subkey, val[subkey]);
                });
            }
            return target.style.setProperty("--" + key, /** @type {?} */ (parse(val)));
        },
        get: function (key) { return target.style.getPropertyValue("--" + key); },
    });
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * input变化监控
 *
 * ```ts
 * const sub = createKeyUp(this.input).switchMap(res => {
 * this.val = res;
 * return this.http.get('https://meepo.com.cn/app/index.php?i=2&c=entry&do=open&m=imeepos_runner&__do=task.getAll')
 * }).subscribe(res => {
 * console.log(res);
 * });
 * ```
 * @param {?} ele
 * @param {?=} time
 * @return {?}
 */
function createKeyUp(ele, time) {
    if (time === void 0) { time = 400; }
    var /** @type {?} */ keyup = fromEvent$1(ele.nativeElement, 'keyup');
    var /** @type {?} */ keydown = fromEvent$1(ele.nativeElement, 'keydown');
    var /** @type {?} */ input = fromEvent$1(ele.nativeElement, 'input');
    var /** @type {?} */ propertychange = fromEvent$1(ele.nativeElement, 'propertychange');
    var /** @type {?} */ observable = merge$1(keyup, keydown, input, propertychange)
        .debounceTime(time)
        .map(function () {
        return ele.nativeElement.value;
    })
        .filter(function (text) { return !!text; })
        .distinctUntilChanged();
    return observable;
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * canvas 转化为图片
 *
 * @param {?} canvas
 * @return {?}
 */
function canvasToImage(canvas) {
    var /** @type {?} */ image = new Image();
    image.src = canvas.toDataURL("image/png");
    return image;
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * 图片转换为canvas
 *
 * @param {?} image
 * @param {?} canvas
 * @return {?}
 */
function imageToCanvas(image, canvas) {
    canvas.width = image.width;
    canvas.height = image.height;
    canvas.getContext("2d").drawImage(image, 0, 0);
    return canvas;
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * 手写签名
 *
 * @param {?} canvas
 * @return {?}
 */
function createWriteRealName(canvas) {
    var /** @type {?} */ ctx = canvas.getContext('2d');
    ctx.beginPath();
    var /** @type {?} */ mousedown = fromEvent$1(canvas, 'mousedown').do(function (e) {
        stopEvent(e);
    }).map(function (e) { return getCanvasPosition(e, canvas); });
    var /** @type {?} */ touchstart = fromEvent$1(canvas, 'touchstart').do(function (e) {
        stopEvent(e);
    }).map(function (e) { return getCanvasPosition(e, canvas); });
    var /** @type {?} */ mouseup = fromEvent$1(canvas, 'mouseup').do(function (e) {
        stopEvent(e);
    });
    var /** @type {?} */ touchend = fromEvent$1(canvas, 'touchend').do(function (e) {
        stopEvent(e);
    });
    var /** @type {?} */ touchmove = fromEvent$1(canvas, 'touchmove').do(function (e) {
        stopEvent(e);
    }).map(function (e) { return getCanvasPosition(e, canvas); });
    var /** @type {?} */ mousemove = fromEvent$1(canvas, 'mousemove').do(function (e) {
        stopEvent(e);
    }).map(function (e) { return getCanvasPosition(e, canvas); });
    var /** @type {?} */ touchStartMove = merge$1(mousedown, touchstart, touchmove, mousemove);
    var /** @type {?} */ movingCombit = touchStartMove.bufferCount(2, 1);
    // 开始
    var /** @type {?} */ start$ = merge$1(mousedown, touchstart)
        .map(function (res) { return ({ data: res, type: 'start' }); });
    // 画图移动
    var /** @type {?} */ move$ = movingCombit.map(function (res) { return ({ data: res, type: 'move' }); });
    // 结束
    var /** @type {?} */ end$ = merge$1(mouseup, touchend).map(function (e) { return ({ type: 'end' }); });
    var /** @type {?} */ moving = false;
    var /** @type {?} */ isWriting$ = merge$1(start$, move$, end$).map(function (res) {
        if (res.type === 'start') {
            moving = true;
        }
        else if (res.type === 'end') {
            moving = false;
        }
        if (moving && res.type === 'move') {
            return res;
        }
        return null;
    });
    // 画完一笔
    isWriting$.subscribe(function (res) {
        if (res) {
            var _a = __read(res.data, 2), first$$1 = _a[0], sec = _a[1];
            ctx.moveTo(first$$1.x, first$$1.y);
            ctx.lineTo(sec.x, sec.y);
            ctx.stroke();
        }
    });
}
/**
 * @param {?} e
 * @return {?}
 */
function stopEvent(e) {
    e.stopPropagation();
    e.preventDefault();
}
/**
 * @param {?} event
 * @param {?} canvas
 * @return {?}
 */
function getCanvasPosition(event, canvas) {
    console.log(event);
    var /** @type {?} */ xPos, /** @type {?} */ yPos, /** @type {?} */ rect;
    rect = canvas.getBoundingClientRect();
    // event = event;
    // Touch event
    if (event.type.indexOf('touch') !== -1) {
        // event.constructor === TouchEvent
        xPos = event.touches[0].clientX - rect.left;
        yPos = event.touches[0].clientY - rect.top;
    }
    else {
        xPos = event.clientX - rect.left;
        yPos = event.clientY - rect.top;
    }
    return {
        x: xPos,
        y: yPos
    };
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @param {?} ele
 * @return {?}
 */
function type(ele) {
    return typeof ele;
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @param {?} num
 * @return {?}
 */
function isNumber(num) {
    if (type(num) === 'string' || num instanceof String) {
        if (!num.trim())
            return false;
    }
    else if (type(num) !== 'number' && !(num instanceof Number)) {
        return false;
    }
    return (num - num + 1) >= 0;
}
/**
 * @param {?} value
 * @return {?}
 */
function isNaN$1(value) {
    return isNumber(value) && value !== +value;
}
/**
 * @param {?} el
 * @return {?}
 */
function isWindow(el) {
    return el !== null && el === el.window;
}
/**
 * @param {?} el
 * @return {?}
 */
function isDocument(el) {
    return el.nodeType === 9;
}
/**
 * @param {?} el
 * @return {?}
 */
function isElement(el) {
    var /** @type {?} */ element = HTMLElement ? HTMLElement : Element;
    if (type(element) === 'function')
        return (el instanceof element);
    return type(el) === 'element' && type(el.nodeName) === 'string';
}
/**
 * @param {?} val
 * @return {?}
 */
function isMeepoTrue(val) {
    if (val === true || val === 'true' || val === undefined || val === null || val === '') {
        return true;
    }
    else {
        return false;
    }
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @param {?} px
 * @return {?}
 */
function fromPx(px) {
    if (type(px) !== 'string')
        return 0;
    var /** @type {?} */ number = Number(px.replace(/px$/, ''));
    return isNaN(number) ? 0 : number;
}
/**
 * @param {?} n
 * @param {?} pos
 * @return {?}
 */
function toPx(n, pos) {
    if (type(n) === 'string')
        return n;
    if (type(n) === 'number')
        return ((pos && n < 0) ? 0 : n) + "px";
    return '0px';
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @param {?} str
 * @return {?}
 */
function ucfirst(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @param {?} el
 * @param {?} prop
 * @param {?=} getComputedStyle
 * @param {?=} style
 * @return {?}
 */
function computedStyle(el, prop, getComputedStyle, style) {
    getComputedStyle = window.getComputedStyle;
    style = getComputedStyle ? getComputedStyle(el) : el.currentStyle;
    if (style) {
        return style[prop.replace(/-(\w)/gi, function (word, letter) {
            return letter.toUpperCase();
        })];
    }
}
/**
 * @param {?} ele
 * @param {?} render
 * @param {?} styles
 * @return {?}
 */
function setStyle(ele, render, styles) {
    for (var /** @type {?} */ key in styles) {
        render.setStyle(ele, key, styles[key]);
    }
}
/**
 * @return {?}
 */
function getWinWidth() {
    return window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
}
/**
 * @return {?}
 */
function getWinHeight() {
    return window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @param {?} node
 * @param {?} className
 * @return {?}
 */
function hasClass(node, className) {
    if (node.classList) {
        return node.classList.contains(className);
    }
    var /** @type {?} */ originClass = node.className;
    return (" " + originClass + " ").indexOf(" " + className + " ") > -1;
}
/**
 * @param {?} node
 * @param {?} className
 * @return {?}
 */
function addClass(node, className) {
    if (node.classList) {
        node.classList.add(className);
    }
    else {
        if (!hasClass(node, className)) {
            node.className = " " + node.className + " " + className;
        }
    }
}
/**
 * @param {?} node
 * @param {?} className
 * @return {?}
 */
function removeClass(node, className) {
    if (node.classList) {
        node.classList.remove(className);
    }
    else {
        if (hasClass(node, className)) {
            var /** @type {?} */ originClass = node.className;
            node.className = (" " + originClass + " ").replace(" " + className + " ", '');
        }
    }
}
/**
 * @param {?} obj
 * @param {?=} srtClassName
 * @return {?}
 */
function ansycClassObj(obj, srtClassName) {
    if (srtClassName === void 0) { srtClassName = ''; }
    for (var /** @type {?} */ key in obj) {
        srtClassName += obj[key] ? " " + key + " " : " ";
    }
    return srtClassName;
}
/**
 * @param {?} arrs
 * @param {?=} to
 * @param {?=} val
 * @param {?=} pre
 * @return {?}
 */
function setClassObj(arrs, to, val, pre) {
    if (to === void 0) { to = {}; }
    if (pre === void 0) { pre = ''; }
    if (type(arrs) === 'string') {
        arrs = arrs.split(',');
    }
    arrs.map(function (arr, index) {
        to[pre + "-" + arr] = val === arr;
    });
    return to;
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @param {?} el
 * @param {?} selector
 * @return {?}
 */
function closest(el, selector) {
    var /** @type {?} */ matchesSelector = el.matches || el.webkitMatchesSelector || el.mozMatchesSelector || el.msMatchesSelector;
    while (el) {
        if (matchesSelector.call(el, selector)) {
            return el;
        }
        el = el.parentElement;
    }
    return null;
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @param {?} el
 * @param {?} name
 * @return {?}
 */
function fromWindow(el, name) {
    return el["client" + ucfirst(name)];
}
/**
 * @param {?} el
 * @param {?} name
 * @return {?}
 */
function fromDocument(el, name) {
    name = ucfirst(name);
    var /** @type {?} */ scroll_name = "scroll" + name;
    var /** @type {?} */ offset_name = "offset" + name;
    var /** @type {?} */ client_name = "client" + name;
    var /** @type {?} */ body_scroll = el.body[scroll_name];
    var /** @type {?} */ document_scroll = el.documentElement[scroll_name];
    var /** @type {?} */ body_offset = el.body[offset_name];
    var /** @type {?} */ document_offset = el.documentElement[offset_name];
    var /** @type {?} */ body_client = el.body[client_name];
    var /** @type {?} */ document_client = el.documentElement[client_name];
    return Math.max(body_scroll, document_scroll, body_offset, document_offset, body_client, document_client);
}
/**
 * @param {?} el
 * @param {?} name
 * @param {?} from
 * @param {?} to
 * @return {?}
 */
function inner(el, name, from$$1, to) {
    if (isWindow(el))
        return fromWindow(el, name);
    if (isDocument(el))
        return fromDocument(el, name);
    if (!isElement(el))
        return null;
    var /** @type {?} */ content = fromPx(computedStyle(el, name));
    var /** @type {?} */ boxSizing = computedStyle(el, 'box-sizing');
    var /** @type {?} */ padding = 0;
    var /** @type {?} */ border = 0;
    if (boxSizing === 'padding-box')
        return content;
    padding += fromPx(computedStyle(el, "padding-" + from$$1));
    padding += fromPx(computedStyle(el, "padding-" + to));
    if (boxSizing === 'border-box') {
        border += fromPx(computedStyle(el, "border-" + from$$1 + "-width"));
        border += fromPx(computedStyle(el, "border-" + to + "-width", to));
    }
    return content + padding - border;
}
/**
 * @param {?} el
 * @param {?} withMargin
 * @param {?} name
 * @param {?} from
 * @param {?} to
 * @return {?}
 */
function outer(el, withMargin, name, from$$1, to) {
    if (isWindow(el))
        return fromWindow(el, name);
    if (isDocument(el))
        return fromDocument(el, name);
    if (!isElement(el))
        return null;
    var /** @type {?} */ content = fromPx(computedStyle(el, name));
    var /** @type {?} */ boxSizing = computedStyle(el, 'box-sizing');
    var /** @type {?} */ padding = 0;
    var /** @type {?} */ border = 0;
    var /** @type {?} */ margin = 0;
    if (boxSizing === 'border-box' && !withMargin)
        return content;
    margin += fromPx(computedStyle(el, "margin-" + from$$1, from$$1));
    margin += fromPx(computedStyle(el, "margin-" + to));
    if (boxSizing === 'border-box' && withMargin)
        return content + margin;
    border += fromPx(computedStyle(el, "border-" + from$$1 + "-width", from$$1));
    border += fromPx(computedStyle(el, "border-" + to + "-width", to));
    if (boxSizing === 'padding-box' && !withMargin)
        return content + border;
    if (boxSizing === 'padding-box' && withMargin)
        return content + border + margin;
    padding += fromPx(computedStyle(el, "padding-" + from$$1));
    padding += fromPx(computedStyle(el, "padding-" + to, to));
    if (!withMargin)
        return content + border + padding;
    return content + border + margin + padding;
}
var DomSize = /** @class */ (function () {
    /**
     * @param {?} ele
     * @param {?} render
     */
    function DomSize(ele, render) {
        this.ele = ele;
        this.render = render;
        this.el = ele;
    }
    /**
     * @return {?}
     */
    DomSize.prototype.innerWidth = function () {
        return inner(this.el, 'width', 'left', 'right');
    };
    /**
     * @return {?}
     */
    DomSize.prototype.innerHeight = function () {
        return inner(this.el, 'height', 'top', 'bottom');
    };
    /**
     * @param {?} value
     * @return {?}
     */
    DomSize.prototype.height = function (value) {
        return this.wh(this.el, value, 'height', 'top', 'bottom');
    };
    /**
     * @param {?} value
     * @return {?}
     */
    DomSize.prototype.width = function (value) {
        return this.wh(this.el, value, 'width', 'left', 'right');
    };
    /**
     * @param {?} withMargin
     * @return {?}
     */
    DomSize.prototype.outerWidth = function (withMargin) {
        return outer(this.el, withMargin, 'width', 'left', 'right');
    };
    /**
     * @param {?} withMargin
     * @return {?}
     */
    DomSize.prototype.outerHeight = function (withMargin) {
        return outer(this.el, withMargin, 'height', 'top', 'bottom');
    };
    /**
     * @param {?} el
     * @param {?} value
     * @param {?} name
     * @param {?} from
     * @param {?} to
     * @return {?}
     */
    DomSize.prototype.wh = function (el, value, name, from$$1, to) {
        if (isWindow(el))
            return fromWindow(el, name);
        if (isDocument(el))
            return fromDocument(el, name);
        if (!isElement(el))
            return null;
        if (type(value) !== 'undefined')
            return this.whSet(el, value, name, from$$1, to);
        return this.whGet(el, name, from$$1, to);
    };
    /**
     * @param {?} el
     * @param {?} value
     * @param {?} name
     * @param {?} from
     * @param {?} to
     * @return {?}
     */
    DomSize.prototype.whSet = function (el, value, name, from$$1, to) {
        var /** @type {?} */ content = fromPx(computedStyle(el, name));
        var /** @type {?} */ boxSizing = computedStyle(el, 'box-sizing');
        var /** @type {?} */ padding = 0;
        var /** @type {?} */ border = 0;
        if (!boxSizing || boxSizing === 'content-box') {
            return this.render.setStyle(el, name, toPx(value, true));
        }
        padding += fromPx(computedStyle(el, "padding-" + from$$1));
        padding += fromPx(computedStyle(el, "padding-" + to, to));
        if (boxSizing === 'padding-box') {
            return this.render.setStyle(el, name, toPx(value + padding, true));
        }
        border += fromPx(computedStyle(el, "border-" + from$$1 + "-width", from$$1));
        border += fromPx(computedStyle(el, "border-" + to + "-width", to));
        value = toPx(value + padding + border, true);
        return this.render.setStyle(el, name, value);
    };
    /**
     * @param {?} el
     * @param {?} name
     * @param {?} from
     * @param {?} to
     * @return {?}
     */
    DomSize.prototype.whGet = function (el, name, from$$1, to) {
        var /** @type {?} */ content = fromPx(computedStyle(el, name));
        var /** @type {?} */ boxSizing = computedStyle(el, 'box-sizing');
        var /** @type {?} */ padding = 0;
        var /** @type {?} */ border = 0;
        if (!boxSizing || boxSizing === 'content-box')
            return content;
        padding += fromPx(computedStyle(el, "padding-" + from$$1));
        padding += fromPx(computedStyle(el, "padding-" + to));
        if (boxSizing === 'padding-box')
            return content - padding;
        border += fromPx(computedStyle(el, "border-" + from$$1 + "-width"));
        border += fromPx(computedStyle(el, "border-" + to + "-width"));
        return content - padding - border;
    };
    return DomSize;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @record
 */
var SignatureAbstract = /** @class */ (function () {
    /**
     * @param {?} element
     * @param {?} render
     */
    function SignatureAbstract(element, render) {
        this.render = render;
        this.defaults = {
            lineColor: '#222222',
            lineWidth: 1,
            border: '1px dashed #AAAAAA',
            background: '#FFFFFF',
            width: 300,
            height: 100,
            autoFit: true
        };
        this.canvas = element;
        this.settings = this.defaults;
        this.domsize = new DomSize(this.canvas, this.render);
        this.currentPos = {
            x: 0,
            y: 0
        };
        this.lastPos = this.currentPos;
    }
    /**
     * @param {?} e
     * @return {?}
     */
    SignatureAbstract.prototype.touchstart = function (e) {
        e.preventDefault();
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SignatureAbstract.prototype.touchmove = function (e) {
        e.preventDefault();
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SignatureAbstract.prototype.touchend = function (e) {
        e.preventDefault();
    };
    /**
     * @param {?} settings
     * @return {?}
     */
    SignatureAbstract.prototype.setSettings = function (settings) {
        this.settings = Object.assign({}, this.settings, settings);
        this.canvas.width = this.settings.width;
        this.canvas.height = this.settings.height;
        this.init();
    };
    /**
     * @return {?}
     */
    SignatureAbstract.prototype.setStyle = function () {
        var /** @type {?} */ style = {
            boxSizing: 'border-box',
            width: this.settings.width + 'px',
            height: this.settings.height + 'px',
            border: this.settings.border,
            background: this.settings.background,
            cursor: 'crosshair'
        };
        for (var /** @type {?} */ k in style) {
            this.render.setStyle(this.canvas, k, style[k]);
        }
    };
    /**
     * @return {?}
     */
    SignatureAbstract.prototype.setAttr = function () {
        this.render.setAttribute(this.canvas, 'width', '' + this.settings.width);
        this.render.setAttribute(this.canvas, 'height', '' + this.settings.height);
    };
    /**
     * @return {?}
     */
    SignatureAbstract.prototype.init = function () {
        var _this = this;
        this.setStyle();
        if (this.settings.autoFit === true) {
            this._resizeCanvas();
        }
        this._resetCanvas();
        var /** @type {?} */ end$ = merge$1(fromEvent$1(this.canvas, 'mouseup'), fromEvent$1(this.canvas, 'touchend'));
        end$.subscribe(function (res) {
            _this.drawing = false;
        });
        var /** @type {?} */ start$ = merge$1(fromEvent$1(this.canvas, 'mousedown'), fromEvent$1(this.canvas, 'touchstart'));
        start$.map(function (e) { return _this._getPosition(e); }).subscribe(function (res) {
            _this.drawing = true;
            _this.lastPos = _this.currentPos = res;
        });
        var /** @type {?} */ move$ = merge$1(fromEvent$1(this.canvas, 'mousemove'), fromEvent$1(this.canvas, 'touchmove'));
        move$.map(function (e) { return _this._getPosition(e); }).subscribe(function (e) {
            _this.currentPos = e;
            _this._renderCanvas();
        });
    };
    /**
     * @return {?}
     */
    SignatureAbstract.prototype.clearCanvas = function () {
        this.canvas.width = this.canvas.width;
        this._resetCanvas();
    };
    /**
     * @return {?}
     */
    SignatureAbstract.prototype.getDataURL = function () {
        return this.canvas.toDataURL();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    SignatureAbstract.prototype._getPosition = function (event) {
        var /** @type {?} */ xPos, /** @type {?} */ yPos, /** @type {?} */ rect;
        rect = this.canvas.getBoundingClientRect();
        if (event instanceof TouchEvent) {
            xPos = event.touches[0].clientX - rect.left;
            yPos = event.touches[0].clientY - rect.top;
        }
        else {
            xPos = event.clientX - rect.left;
            yPos = event.clientY - rect.top;
        }
        return {
            x: xPos,
            y: yPos
        };
    };
    ;
    /**
     * @return {?}
     */
    SignatureAbstract.prototype._renderCanvas = function () {
        if (this.drawing) {
            this.ctx.moveTo(this.lastPos.x, this.lastPos.y);
            this.ctx.lineTo(this.currentPos.x, this.currentPos.y);
            this.ctx.stroke();
            this.lastPos = this.currentPos;
        }
    };
    /**
     * @return {?}
     */
    SignatureAbstract.prototype._resetCanvas = function () {
        this.ctx = this.canvas.getContext("2d");
        this.ctx.strokeStyle = this.settings.lineColor;
        this.ctx.lineWidth = this.settings.lineWidth;
    };
    /**
     * @return {?}
     */
    SignatureAbstract.prototype._resizeCanvas = function () {
        var /** @type {?} */ width = this.domsize.outerWidth(true);
        this.render.setAttribute(this.canvas, 'width', width);
    };
    return SignatureAbstract;
}());
SignatureAbstract.propDecorators = {
    "touchstart": [{ type: HostListener, args: ['touchstart', ['$event'],] },],
    "touchmove": [{ type: HostListener, args: ['touchmove', ['$event'],] },],
    "touchend": [{ type: HostListener, args: ['touchend', ['$event'],] },],
};
var Signature = /** @class */ (function (_super) {
    __extends(Signature, _super);
    function Signature() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return Signature;
}(SignatureAbstract));
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var Scroller = /** @class */ (function () {
    /**
     * @param {?} ele
     */
    function Scroller(ele) {
        this.ele = ele;
    }
    /**
     * @return {?}
     */
    Scroller.prototype.getViewportScrollPosition = function () {
        var /** @type {?} */ ele = this.ele.nativeElement;
        var /** @type {?} */ documentRect = ele.getBoundingClientRect();
        var /** @type {?} */ top = -documentRect.top || ele.scrollTop || 0;
        var /** @type {?} */ left = -documentRect.left || ele.scrollLeft || 0;
        return { top: top, left: left };
    };
    /**
     * @return {?}
     */
    Scroller.prototype._updateViewportSize = function () {
        this._viewportSize = {
            width: this.ele.nativeElement.offsetWidth,
            height: this.ele.nativeElement.offsetHeight
        };
    };
    /**
     * @return {?}
     */
    Scroller.prototype.getViewportSize = function () {
        if (!this._viewportSize || !this._viewportSize.height || !this._viewportSize.width) {
            this._updateViewportSize();
        }
        return {
            width: this._viewportSize.width,
            height: this._viewportSize.height
        };
    };
    /**
     * @return {?}
     */
    Scroller.prototype.getViewportRect = function () {
        var /** @type {?} */ scrollPosition = this.getViewportScrollPosition();
        var _a = this.getViewportSize(), width = _a.width, height = _a.height;
        return {
            top: scrollPosition.top,
            left: scrollPosition.left,
            bottom: scrollPosition.top + height,
            right: scrollPosition.left + width,
            height: height,
            width: width,
        };
    };
    return Scroller;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var IconBase = /** @class */ (function () {
    /**
     * @param {?} _elementRef
     */
    function IconBase(_elementRef) {
        this._elementRef = _elementRef;
    }
    return IconBase;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */
export { ANNOTATIONS, PARAMETERS, PROP_METADATA, makeDecorator, makeParamDecorator, makePropDecorator, styledash, createKeyUp, canvasToImage, imageToCanvas, createWriteRealName, stopEvent, getCanvasPosition, isNumber, isNaN$1 as isNaN, isWindow, isDocument, isElement, isMeepoTrue, fromPx, toPx, ucfirst, computedStyle, setStyle, getWinWidth, getWinHeight, type, hasClass, addClass, removeClass, ansycClassObj, setClassObj, closest, fromWindow, DomSize, SignatureAbstract, Signature, Scroller, IconBase };
export { of$1 as of } from 'rxjs/observable/of';
export { empty$1 as empty } from 'rxjs/observable/empty';
export { from$1 as from } from 'rxjs/observable/from';
export { interval$1 as interval } from 'rxjs/observable/interval';
export { timer$1 as timer } from 'rxjs/observable/timer';
export { fromEvent$1 as fromEvent } from 'rxjs/observable/fromEvent';
export { fromPromise$1 as fromPromise } from 'rxjs/observable/fromPromise';
export { range$1 as range } from 'rxjs/observable/range';
export { fromEventPattern$1 as fromEventPattern } from 'rxjs/observable/fromEventPattern';
export { combineLatest$1 as combineLatest } from 'rxjs/observable/combineLatest';
export { concat$1 as concat } from 'rxjs/observable/concat';
export { forkJoin$1 as forkJoin } from 'rxjs/observable/forkJoin';
export { merge$1 as merge } from 'rxjs/observable/merge';
export { race$1 as race } from 'rxjs/observable/race';
export { zip$1 as zip } from 'rxjs/observable/zip';
export { Scheduler$1 as Scheduler } from 'rxjs/Scheduler';
export { Subject$1 as Subject } from 'rxjs/Subject';
export { Observable$1 as Observable } from 'rxjs/Observable';
//# sourceMappingURL=meepo-utils.js.map
