export interface SignatureConfig {
    lineColor?: string;
    lineWidth?: number;
    border?: string;
    background?: string;
    width?: number;
    height?: number;
    autoFit?: boolean;
}
import { Renderer2 } from '@angular/core';
import { DomSize } from './dom';
export declare class SignatureAbstract {
    render: Renderer2;
    defaults: SignatureConfig;
    canvas: HTMLCanvasElement;
    settings: SignatureConfig;
    ctx: CanvasRenderingContext2D;
    domsize: DomSize;
    drawing: boolean;
    lastPos: any;
    currentPos: any;
    touchstart(e: any): void;
    touchmove(e: any): void;
    touchend(e: any): void;
    constructor(element: HTMLCanvasElement, render: Renderer2);
    setSettings(settings: SignatureConfig): void;
    setStyle(): void;
    setAttr(): void;
    init(): void;
    clearCanvas(): void;
    getDataURL(): string;
    _getPosition(event: MouseEvent | TouchEvent): {
        x: any;
        y: any;
    };
    _renderCanvas(): void;
    _resetCanvas(): void;
    _resizeCanvas(): void;
}
export declare class Signature extends SignatureAbstract {
}
